﻿-----------------------------------------------------------------------------------------
--Dispel Frame---------------------------------------------------------------------------
-----------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")

local UnitAura = UnitAura
local GetSpellLink = GetSpellLink
local UnitGUID = UnitGUID
local UnitName = UnitName
local UnitIsEnemy = UnitIsEnemy
local unpack = unpack

local dispelSpell

function SN:SetupDispel()

	F.dispel = CreateFrame("Frame", nil, UIParent)
	F.dispel:SetPoint(unpack(SN.data.profile.frames.dispel))
	F.dispel:SetWidth(250)
	F.dispel:SetHeight(75)
	F.dispel:SetClampedToScreen(true)
	
	F.dispel.TimeSinceLastUpdate = 0
	F.dispel.dispelSpell = nil
	F.dispel.spell = nil
	F.dispel.name = "Dispel Frame"
	F.dispel.db = "dispel"

	F.dispel:SetScript("OnEvent", function(self, event, ...)
		SN:DispelEvents(self, event, ...)
	end)

	F.dispel.value = F.dispel:CreateFontString(nil, "ARTWORK")
	F.dispel.value:SetFont(LSM:Fetch("font", SN.data.profile.dispel.font), SN.data.profile.dispel.fontsize, "OUTLINE")
	F.dispel.value:SetText("")
	F.dispel.value:SetAllPoints(F.dispel)
	F.dispel.value:SetJustifyH("CENTER")
	F.dispel.value:SetJustifyV("MIDDLE")
	
	if SN.data.profile.dispel.enable then
		SN:DispelEnable()
	else
		SN:DispelDisable()
	end
end

function SN:SearchBuffs(self, elapsed)
	--Make sure we don't hog cpu cycles checking it every millisecond
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
	if self.TimeSinceLastUpdate > SN.UpdateIntervalDispel then

		self.TimeSinceLastUpdate = 0
		for i = 1, 40 do

			local stealableBuffs -- i = { }, 1
			local name, _, icon, _, debuffType, _, _, _, _, _, spellId, _, _ = UnitAura("target", i, "HELPFUL")
				
			if name ~= nil then
				
				local canDispel, dispelSpell = SN.dispel:CanDispel("target", true, debuffType, spellId)
				if canDispel then
					self.value:SetText(L["You can "]..GetSpellLink(dispelSpell).."\n"..name..L[" from "].."\n"..UnitName("target"))
					self.dispelSpell = dispelSpell
					self.spell = spellId
				end
			end
		end
	end
end

function SN:DispelEvents(self, event, ...)

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if SN.data.profile.dispel.enable then
			local _, type, _, sourceGUID, sourceName, _, _, destGUID, destName = ...
			local spellId, spellName = select(12, ...)
			--Reset text after the Buff has been dispeled
			if type == "SPELL_AURA_REMOVED" or "SPELL_DISPEL" or "SPELL_AURA_STOLEN" then
				if destGUID == UnitGUID("target") and spellId == self.spell then
					self.value:SetText("")
					self.dispelSpell = nil
				end
			end
		end
	end

	if event == "PLAYER_REGEN_ENABLED" or "PLAYER_TARGET_CHANGED" then
		--self.value:SetText("")
		self.dispelSpell = nil
	end
end

function SN:DispelEnable()
	F.dispel:Show()
	F.dispel:RegisterEvent("PLAYER_REGEN_ENABLED")
	F.dispel:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	F.dispel:RegisterEvent("PLAYER_TARGET_CHANGED")
	--F.dispel:RegisterEvent("UNIT_AURA")

	F.dispel:SetScript("OnUpdate", function(self, elapsed)
		if SN.data.profile.dispel.enable and UnitIsEnemy("player", "target") == 1 then
			SN:SearchBuffs(self, elapsed)
		end
	end)
	collectgarbage("collect")
end

function SN:DispelDisable()
	F.dispel:UnregisterAllEvents()
	--F.dispel:RegisterEvent("UNIT_AURA")

	F.dispel:SetScript("OnUpdate", nil)
	F.dispel:Hide()
	collectgarbage("collect")
end